Package org.apache.sysds.hops

## Class FunctionOp

- java.lang.Object
- - org.apache.sysds.hops.Hop
  - - org.apache.sysds.hops.FunctionOp

- All Implemented Interfaces:
    `ParseInfo`

      public class FunctionOp
      extends Hop

  This FunctionOp represents the call to a DML-bodied or external function. Note: Currently, we support expressions in function arguments along with function calls in expressions with single outputs, leaving multiple outputs handling as it is.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `static class` | `FunctionOp.FunctionType` |

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `OPCODE` |

    - ### Fields inherited from class org.apache.sysds.hops.Hop

      `_beginColumn, _beginLine, _endColumn, _endLine, _filename, _text, CPThreshold`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FunctionOp​(FunctionOp.FunctionType type, String fnamespace, String fname, String[] inputNames, List<Hop> inputs, String[] outputNames, boolean singleOut)` |
    `FunctionOp​(FunctionOp.FunctionType type, String fnamespace, String fname, String[] inputNames, List<Hop> inputs, String[] outputNames, boolean singleOut, boolean pseudo)` |
    `FunctionOp​(FunctionOp.FunctionType type, String fnamespace, String fname, String[] inputNames, List<Hop> inputs, String[] outputNames, ArrayList<Hop> outputHops)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `boolean` | `allowsAllExecTypes()` |
    `void` | `checkArity()` | FunctionOps may have any number of inputs.
    `Object` | `clone()` |
    `boolean` | `compare​(Hop that)` |
    `void` | `computeMemEstimate​(MemoTable memo)` | Computes the estimate of memory required to store the input/output of this hop in memory.
    `Lop` | `constructLops()` |
    `boolean` | `containsOutput​(String varname)` |
    `String` | `getFunctionKey()` |
    `String` | `getFunctionName()` |
    `String` | `getFunctionNamespace()` |
    `FunctionOp.FunctionType` | `getFunctionType()` |
    `String[]` | `getInputVariableNames()` |
    `String` | `getOpString()` |
    `ArrayList<Hop>` | `getOutputs()` |
    `String[]` | `getOutputVariableNames()` |
    `boolean` | `isGPUEnabled()` | In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop.
    `boolean` | `isPseudoFunctionCall()` |
    `void` | `refreshSizeInformation()` | Update the output size information for this hop.
    `void` | `setCallOptimized​(boolean opt)` |
    `void` | `setFunctionName​(String fname)` |
    `void` | `setFunctionNamespace​(String fnamespace)` |
    `void` | `setInputVariableNames​(String[] names)` |
    `String` | `toString()` |

    - ### Methods inherited from class org.apache.sysds.hops.Hop

      `activatePrefetch, addAllInputs, addInput, checkAndSetForcedPlatform, checkAndSetInvalidCPDimsAndSize, clearMemEstimate, colsKnown, compressedSize, computeBoundsInformation, computeBoundsInformation, computeBoundsInformation, computeSizeInformation, computeSizeInformation, computeSizeInformation, constructAndSetLopsDataFlowProperties, createOffsetLop, deactivatePrefetch, dimsKnown, dimsKnown, dimsKnownAny, federatedCostInitialized, getBeginColumn, getBeginLine, getBlocksize, getCompressedSize, getDataCharacteristics, getDataType, getDim, getDim1, getDim2, getEndColumn, getEndLine, getExecType, getFederatedCost, getFederatedOutput, getFilename, getForcedExecType, getHopID, getInput, getInput, getInputMemEstimate, getInputMemEstimate, getInputOutputSize, getIntermediateMemEstimate, getLength, getLops, getMemEstimate, getName, getNnz, getOutputMemEstimate, getOutputMemEstimate, getParent, getPrivacy, getRepetitions, getSparsity, getSpBroadcastSize, getText, getUpdateType, getValueType, hasCompressedInput, hasFederatedOutput, hasLocalOutput, hasMatrixInputWithDifferentBlocksizes, hasValidCPDimsAndSize, isCompressedOutput, isFederated, isFederatedDataOp, isMatrix, isMemEstimated, isOutputEmptyBlocks, isRequiredDecompression, isScalar, isTransposeSafe, isVisited, prefetchActivated, printErrorLocation, refreshColsParameterInformation, refreshColsParameterInformation, refreshMemEstimates, refreshRowsParameterInformation, refreshRowsParameterInformation, requiresCheckpoint, requiresCompression, requiresLineageCaching, requiresReblock, requiresRecompile, resetExecType, resetFederatedCost, resetRecompilationFlag, resetRecompilationFlag, resetVisitStatus, resetVisitStatus, resetVisitStatus, resetVisitStatusForced, rowsKnown, setBeginColumn, setBeginLine, setBlocksize, setCompressedOutput, setCompressedSize, setDataType, setDim, setDim1, setDim2, setEndColumn, setEndLine, setExecType, setFederatedCost, setFederatedOutput, setFilename, setForcedExecType, setLops, setMemEstimate, setName, setNnz, setOutputEmptyBlocks, setParseInfo, setPrivacy, setRequiresCheckpoint, setRequiresCompression, setRequiresCompression, setRequiresDeCompression, setRequiresLineageCaching, setRequiresReblock, setRequiresRecompile, setText, setUpdateType, setValueType, setVisited, setVisited, someInputFederated, updateLopFedOut, updateLopFedOut, updateRepetitionEstimates`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### OPCODE

          public static final String OPCODE

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### FunctionOp

          public FunctionOp​(FunctionOp.FunctionType type,
                            String fnamespace,
                            String fname,
                            String[] inputNames,
                            List<Hop> inputs,
                            String[] outputNames,
                            ArrayList<Hop> outputHops)

    - #### FunctionOp

          public FunctionOp​(FunctionOp.FunctionType type,
                            String fnamespace,
                            String fname,
                            String[] inputNames,
                            List<Hop> inputs,
                            String[] outputNames,
                            boolean singleOut)

    - #### FunctionOp

          public FunctionOp​(FunctionOp.FunctionType type,
                            String fnamespace,
                            String fname,
                            String[] inputNames,
                            List<Hop> inputs,
                            String[] outputNames,
                            boolean singleOut,
                            boolean pseudo)

  - ### Method Detail

    - #### checkArity

          public void checkArity()

      FunctionOps may have any number of inputs.
      Specified by:
        `checkArity` in class `Hop`

    - #### getFunctionKey

          public String getFunctionKey()

    - #### getFunctionNamespace

          public String getFunctionNamespace()

    - #### getFunctionName

          public String getFunctionName()

    - #### setFunctionName

          public void setFunctionName​(String fname)

    - #### setFunctionNamespace

          public void setFunctionNamespace​(String fnamespace)

    - #### setInputVariableNames

          public void setInputVariableNames​(String[] names)

    - #### getOutputs

          public ArrayList<Hop> getOutputs()

    - #### getInputVariableNames

          public String[] getInputVariableNames()

    - #### getOutputVariableNames

          public String[] getOutputVariableNames()

    - #### containsOutput

          public boolean containsOutput​(String varname)

    - #### getFunctionType

          public FunctionOp.FunctionType getFunctionType()

    - #### setCallOptimized

          public void setCallOptimized​(boolean opt)

    - #### isPseudoFunctionCall

          public boolean isPseudoFunctionCall()

    - #### allowsAllExecTypes

          public boolean allowsAllExecTypes()

      Specified by:
        `allowsAllExecTypes` in class `Hop`

    - #### computeMemEstimate

          public void computeMemEstimate​(MemoTable memo)

      Description copied from class: `Hop`
      Computes the estimate of memory required to store the input/output of this hop in memory. This is the default implementation (orchestration of hop-specific implementation) that should suffice for most hops. If a hop requires more control, this method should be overwritten with awareness of (1) output estimates, and (2) propagation of worst-case matrix characteristics (dimensions, sparsity). TODO remove memo table and, on constructor refresh, inference in refresh, single compute mem, maybe general computeMemEstimate, flags to indicate if estimate or not.
      Overrides:
        `computeMemEstimate` in class `Hop`
      Parameters:
        `memo` - memory table

    - #### isGPUEnabled

          public boolean isGPUEnabled()

      Description copied from class: `Hop`
      In memory-based optimizer mode (see OptimizerUtils.isMemoryBasedOptLevel()), the exectype is determined by checking this method as well as memory budget of this Hop. Please see findExecTypeByMemEstimate for more detail. This method is necessary because not all operator are supported efficiently on GPU (for example: operations on frames and scalar as well as operations such as table).
      Specified by:
        `isGPUEnabled` in class `Hop`
      Returns:
        true if the Hop is eligible for GPU Exectype.

    - #### constructLops

          public Lop constructLops()

      Specified by:
        `constructLops` in class `Hop`

    - #### getOpString

          public String getOpString()

      Specified by:
        `getOpString` in class `Hop`

    - #### refreshSizeInformation

          public void refreshSizeInformation()

      Description copied from class: `Hop`
      Update the output size information for this hop.
      Specified by:
        `refreshSizeInformation` in class `Hop`

    - #### clone

          public Object clone()
                       throws CloneNotSupportedException

      Specified by:
        `clone` in class `Hop`
      Throws:
        `CloneNotSupportedException`

    - #### compare

          public boolean compare​(Hop that)

      Specified by:
        `compare` in class `Hop`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Hop`